#include "tutor.h"
#include "decl_vect_matr.h"

void vue(_module_ *modu, D3DVECTOR b, LPDIRECT3DDEVICE9* _obj_Direct3DDevice) {

	D3DVECTOR w = {0.0f, 1.0f, 0.0f};
	D3DVECTOR v = soustraction(b,modu->position_cam);
	D3DVECTOR unit_v = normalisation(v);

	D3DVECTOR landa = scalaire(produit_scalaire(w, unit_v), unit_v);

	D3DVECTOR u = soustraction(w, landa);
	D3DVECTOR unit_u = normalisation(u);

	D3DVECTOR unit_r;

	// produit vectoriel
	unit_r = produit_vectoriel(unit_u, unit_v);

	// initialisation de la matrice
	modu->view_matr._11=unit_r.x;
	modu->view_matr._21=unit_r.y;
	modu->view_matr._31=unit_r.z;
	modu->view_matr._12=unit_u.x;
	modu->view_matr._22=unit_u.y;
	modu->view_matr._32=unit_u.z;
	modu->view_matr._13=unit_v.x;
	modu->view_matr._23=unit_v.y;
	modu->view_matr._33=unit_v.z;
	modu->view_matr._41=-unit_r.x*modu->position_cam.x-unit_r.y*modu->position_cam.y-unit_r.z*modu->position_cam.z;
	modu->view_matr._42=-unit_u.x*modu->position_cam.x-unit_u.y*modu->position_cam.y-unit_u.z*modu->position_cam.z;
	modu->view_matr._43=-unit_v.x*modu->position_cam.x-unit_v.y*modu->position_cam.y-unit_v.z*modu->position_cam.z;
	modu->view_matr._14=0.0f;
	modu->view_matr._24=0.0f;
	modu->view_matr._34=0.0f;
	modu->view_matr._44=1.0f;

}

void vue_settransf(_module_ *modu,LPDIRECT3DDEVICE9* _obj_Direct3DDevice) {

	// D3DTRANSFORMSTATE_VIEW : drapeau indiquant
	// qu'il s'agit d'une matrice de vue

	// dfinit la matrice de vue  l'interface graphique
	(*_obj_Direct3DDevice)->SetTransform(D3DTS_VIEW, &(modu->view_matr));

}
